options ls=130 nocenter nofmterr;

libname here '.';


* set up to put out residual covariances of indicators and single y outcome;
* Plus the var-cov matrix of the residual covariances;

* main output = rescov.dat ( 45 row vector of residual covariances (LTR format) ;
*               vrescov.dat = 45*45 matrix output in vec format (1 column) ; 



data one;
set here.extract;


%let n=9473;

exp1=age1-schooling-5;
exp2=exp1+1;
exp3=exp1+2;
exp4=exp1+3;
exp5=exp1+4;
exp6=exp1+5;
exp7=exp1+6;
exp8=exp1+7;
exp9=exp1+8;

array cexp (*) exp1-exp9;
array cexpsq (*) expsq1-expsq9;


do i=1 to 9;
cexpsq(i)=cexp(i)**2;
end;

w1=log(g1/h1);
w2=log(g2/h2);
w3=log(g3/h3);
w4=log(g4/h4);
w5=log(g5/h5);
w6=log(g6/h6);
w7=log(g7/h7);
w8=log(g8/h8);
w9=log(g9/h9);



proc means;
var w1-w9 exp1-exp9 schooling ;

*step 1 = get residuals from indicators and y var (last in list);



proc glm;
class year1;
model w1=exp1 expsq1 year1 /solution;
output out=new
 r=r1;

proc glm;
class year2;
model w2=exp2 expsq2 year2 / solution;
output out=new
 r=r2;

proc glm;
class year3;
model w3=exp3 expsq3 year3/ solution;
output out=new
 r=r3;

proc glm;
class year4;
model w4=exp4 expsq4 year4 /solution;
output out=new
 r=r4;

proc glm;
class year5;
model w5=exp5 expsq5 year5 /solution;
output out=new
 r=r5;

proc glm;
class year6;
model w6=exp6 expsq6 year6 /solution;
output out=new
 r=r6;

proc glm;
class year7;
model w7=exp7 expsq7 year7 /solution;
output out=new
 r=r7;

proc glm;
class year8;
model w8=exp8 expsq8 year8 /solution;
output out=new
 r=r8;

proc glm;
class year9;
model w9=exp9 expsq9 year9 /solution;
output out=new
 r=r9;


proc corr cov;
var r1-r9;

*step 2: construct m = ltr format  residual covariance elements;

data covs;
set new (keep=r1-r9);
array res (*) r1-r9;
array m (*) m1-m45;

index=1;
do j=1 to 9;
do k=1 to j;
 m(index)=res(k)*res(j);
 index=index+1;
end;
end;

proc means n mean stderr;
var m1-m45;
output out=m2
mean=;

data m2b;
set m2;
keep m1-m45;

proc transpose data=m2b out=m2t;
proc print data=m2t;
var col1;  /*this is now a row vector of the LTR mean residual covariances*/


*step 3: construct outer product  Sum { m(i) m(i)'} / N  = var-cov of m;



proc corr cov nocorr nosimple data=covs outp=m4;
var m1-m45;

data m4b;
set m4;
if _type_="COV";
id=_n_;
keep id m1-m45;

data check;
set m4b;
array m (*) m1-m45;

se=sqrt( m(id)/&n. );
keep id  se;

*check of calculations - note df = N;
proc print data=check; 


*step 4: output the res-covs and their var-cov matrix;

data o1;
set m2t;
file './rescov.dat';
put col1 12.9;

data o2;
set m4b;
file './vrescov.dat';
array m (*) m1-m45;
do j=1 to 45;
 y=m(j)/&n. ;
 put y 12.9;
end;


